// Every package should have a minimal demo, so here is the white triangle in GLUGG version.

#ifdef __APPLE__
	#include <OpenGL/gl3.h>
	#include "MicroGlut.h"
// uses framework Cocoa
#else
	#include <GL/glut.h>
#endif
#include "GL_utilities.h"
#include "VectorUtils3.h"
#include "glugg.h"

GLuint program; // Shader
GLuint triangle; // VAO for the triangle

void draw(void)
{
	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
	
	glBindVertexArray(triangle);	// Select VAO
	glDrawArrays(GL_TRIANGLES, 0, 3);
	
	glutSwapBuffers();
}

void init(void)
{
	program = loadShaders("minimal.vert", "minimal.frag");
	
	/* make the triangle */
	int count;
	gluggBegin(GLUGG_TRIANGLES);
	gluggVertex(-0.5,-0.5,0);
	gluggVertex(0.5,-0.5,0);
	gluggVertex(-0.5,0.5,0);
	triangle = gluggEnd(&count, program, 0);
}

int main(int argc, char *argv[])
{
	glutInit(&argc, argv);
	
	glutInitDisplayMode(GLUT_RGB | GLUT_DOUBLE);
	glutInitContextVersion(3, 2);

	glutCreateWindow("GLUGG White Triangle");
	init();
	glutDisplayFunc(draw);

	glutMainLoop();
	return 0;
}
